# local_rpm_repo

[![pipeline status](https://gitlab.com/arden-puppet/arden-local_rpm_repo/badges/master/pipeline.svg)](https://gitlab.com/arden-puppet/arden-local_rpm_repo/commits/master)
[![Version](https://img.shields.io/puppetforge/v/arden/local_rpm_repo.svg)](https://forge.puppet.com/arden/local_rpm_repo)

#### Table of Contents

1. [Description](#description)
2. [Setup - The basics of getting started with local_rpm_repo](#setup)
    * [What local_rpm_repo affects](#what-local_rpm_repo-affects)
    * [Setup requirements](#setup-requirements)
3. [Usage - Configuration options and additional functionality](#usage)
4. [Limitations - OS compatibility, etc.](#limitations)
5. [Development - Guide for contributing to the module](#development)

## Description

This module allows you to create and deploy a http based RPM repository using a tar of RPMs as a source. This can be helpful for environments where some number of locally created and maintained RPMs must be distributed to a set of systems.

I use this to automatically maintain a simple repo containing a ppc64 build of puppet-agent.

## Setup

### What local_rpm_repo affects

It creates an apache vhost on the target machine and schedules a cron job of `createrepo` for each repository specified in the config. The repos will be within the specified vhost in their own folders.

### Setup Requirements 

This module assumes you have a simple web server configured to host a tar file for each repository you intend to deploy. Currently, it is assumed that the tar contains a directory tree beginning with `./el` in which one or more RPMs are stored.

Tar files for each repository should be created and named with a format similar to `${reponame}-${version}.tar`. For example, a repo named *test-repo* with a version string of *1.6.3* would have a corresponding tar named `test-repo-1.6.3.tar`.

## Usage

The example below will configure three repos named repo1, repo2, and repo3 respectively on the target node. This node will expect connections to arrive to the vhost `yum.example.com`.

When puppet is applying this configuration it will expect to be able to download the following three files:
* `http://bin.example.com/data/repo1-5.0.3.1.tar`
* `http://bin.example.com/data/repo2-1.0.7.0.tar`
* `http://bin.example.com/data/repo3-dev-1.0.0.0.tar`

```yaml
---
local_rpm_repo:source_base_url: 'http://bin.example.com/data/'
local_rpm_repo:mirror_fqdn: 'yum.example.com'
local_rpm_repo:repo_list:
  repo1:
    version: '5.0.3.1'
  repo2:
    version: '1.0.7.0'
  repo3:
    source_prefix: 'repo3-dev'
    version: '1.0.0.0'
```

## Limitations

* Currently GPG signing of repositories is not supported.

## Development

TBD.

## Contributors

Check out the [contributor list](https://gitlab.com/arden-puppet/arden-local_rpm_repo/graphs/master).
