# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`local_rpm_repo`](#local_rpm_repo): Creates and hosts the specified RPM repositories.

## Classes

### local_rpm_repo

A simple class to create and manage locally maintained repositories using
tar file containing the RPMs.

#### Examples

##### Definition of three repositories

```puppet
class { 'local_rpm_repo':
 source_base_url => 'http://puppet.arden/data/',
 mirror_fqdn     => 'yum.puppet.arden',
 repo_list       => {
                      'arden-local'        => { version => '1.0.0.0' },
                      'arden-local-dev'    => { version => '1.0.0.0' },
                      'arden-local-source' => { version => '1.0.0.0' },
                    }
}
```

#### Parameters

The following parameters are available in the `local_rpm_repo` class.

##### `mirror_fqdn`

Data type: `String`

Fully Qualified Domain Name which will be used as the apache vhost name on
this server. Note that this FQDN should resolve to this server.

Default value: `undef`

##### `source_base_url`

Data type: `String`

This specifies the URL from which the repo tar should be extracted. Note
that the application assumes all of the tar files are located within the
specified directory. For example, `http://bin.arden/data` should contain a
file for each repo of the form `${source_prefix}-${version}.tar.`

Default value: `undef`

##### `repo_base_path`

Data type: `String`

Absolute path to the parent directory of the yum repository

Default value: '/var/yumrepos'

##### `repo_base_cache_path`

Data type: `String`

Absolute path to the parent directory of the yum repository cache
directory.

Default value: '/var/cache/yumrepos'

##### `repo_list`

Data type: `Hash[String, Optional[Hash[String, String]]]`

A hash where the keys are the names of the repos to be deployed. The
following options are supported for each repo:
   version       [String]  - version of the source repo file
   source_prefix [String]  - prefix of the file, defaults to the repo name.

Note that at least one repository must be specified

Default value: []

